import 'package:flutter_test/flutter_test.dart';
import 'package:stokkur_api_client/stokkur_api_client.dart';

import 'constants.dart';

void main() {
  test('Api client is a singleton', () {
    const String _otherUrl = 'https://mockjsonplaceholder.mock.com';

    final apiClient1 = ApiClient(
      baseUrl: Constants.baseUrl,
      headers: Constants.defaultHeader,
    );

    expect(apiClient1.dio.options.baseUrl, Constants.baseUrl);
    expect(apiClient1.dio.interceptors, isEmpty);

    final apiClient2 = ApiClient(
      baseUrl: _otherUrl,
      headers: Constants.defaultHeader,
      interceptors: [NetworkLoggerInterceptor()],
    );

    expect(apiClient2.dio.options.baseUrl, _otherUrl);
    expect(apiClient2.dio.interceptors, isNotEmpty);

    expect(apiClient1.dio.options.baseUrl, _otherUrl);
    expect(apiClient1.dio.interceptors, isNotEmpty);

    // This is the only test that matters:
    expect(apiClient1, apiClient2);
  });
}
